﻿using MedicalDatabaseContracts.Models;

namespace MedicalDatabaseContracts
{
    public interface IStorage<T> where T : AbstractModel
    {
        T? Get(int id, out double elapsedMilliseconds);
        T? Get(int id);
        List<T> GetAll(out double elapsedMilliseconds);
        List<T> GetAll();
        void Insert(T item, out double elapsedMilliseconds);
        void Insert(T item);
        void Update(T item, out double elapsedMilliseconds);
        void Update(T item);
        void Delete(int id, out double elapsedMilliseconds);
        void Delete(int id);
        void DeleteAll(out double elapsedMilliseconds);
        void DeleteAll();
    }
}
