﻿using MedicalDatabaseContracts.Models;
using Microsoft.Extensions.Logging;
using Npgsql;
using System.Data;

namespace MedicalPostgresqlDatabase.Storages
{
    public class DiagnoseStorage : AbstractPostgresqlStorage<Diagnose>
    {
        public DiagnoseStorage(ILogger<DiagnoseStorage> logger) : base(logger, "diagnoses", "diagnose_id", "diagnoses_id_seq") { }

        protected override Diagnose CreateEntityFromReader(NpgsqlDataReader reader)
        {
            return new Diagnose
            {
                Id = Convert.ToInt32(reader.GetValue(PRIMARY_KEY_COLUMN_NAME)),
                Name = Convert.ToString(reader.GetValue("name")),
            };
        }

        protected override Dictionary<string, object> GetEntityAttributesDictionary(Diagnose item)
        {
            var dict = new Dictionary<string, object>
            {
                { PRIMARY_KEY_COLUMN_NAME, item.Id },
                { "name", item.Name },
            };
            return dict;
        }
    }
}
